package io.educative.soap.tests;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertNotNull;
import static org.testng.Assert.assertTrue;

import org.testng.annotations.BeforeClass;
import org.testng.annotations.Test;

import io.educative.soap.helpers.StudentServiceHelper;
import io.educative.soap_automation.GetStudentsResponse;

public class TestGetStudents extends BaseTest {

	private StudentServiceHelper helperWithoutAuth;
	private StudentServiceHelper helperWithAuth;

	@BeforeClass
	public void initHelper() {
		helperWithoutAuth = new StudentServiceHelper(webServiceTemplate);
		helperWithAuth = new StudentServiceHelper(webServiceTemplate, true);
	}

	@Test
	public void testStudentById() {

		long id = 100;

		// Fetching the created Student response
		GetStudentsResponse getStudentsResponse = helperWithoutAuth.getStudentById(id);

		validateResponse(getStudentsResponse);
	}

	@Test
	public void testStudentByIdWithAuth() {

		long id = 100;

		// Fetching the created Student response
		GetStudentsResponse getStudentsResponse = helperWithAuth.getStudentById(id);

		validateResponse(getStudentsResponse);

	}

	private void validateResponse(GetStudentsResponse getStudentsResponse) {
		// Validating response is not null and contains more than one object
		assertNotNull(getStudentsResponse, "GetStudentsResponse is null");
		assertTrue(!getStudentsResponse.getStudents().isEmpty(), "students list is empty");
		assertEquals(getStudentsResponse.getStudents().get(0).getFirstName(), "John", "first name");

		printResponse(getStudentsResponse);
	}
}